package com.zhongshu.card.server.core.dao.school.impl;

import com.github.microservice.components.data.mongo.mongo.helper.DBHelper;
import com.zhongshu.card.client.model.school.CardInfoPoolSearch;
import com.zhongshu.card.server.core.dao.BaseImpl;
import com.zhongshu.card.server.core.dao.school.extend.CardInfoPoolDaoExtend;
import com.zhongshu.card.server.core.domain.school.CardInfoPool;
import com.zhongshu.card.server.core.util.CommonUtil;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Pattern;

/**
 * @Author TRX
 * @CreateDate: 2023/4/12
 * @Version: 1.0
 */
public class CardInfoPoolDaoImpl extends BaseImpl implements CardInfoPoolDaoExtend {

    @Autowired
    private DBHelper dbHelper;

    @Override
    public Page<CardInfoPool> page(Pageable pageable, CardInfoPoolSearch param) {
        Criteria criteria = new Criteria();

        // 学校ID
        if (ObjectUtils.isNotEmpty(param.getOid())) {
            criteria.and("oid").is(param.getOid());
        }
        // 所属项目oid
        if (ObjectUtils.isNotEmpty(param.getProjectOid())) {
            criteria.and("projectOid").is(param.getProjectOid());
        }

        if (ObjectUtils.isNotEmpty(param.getSchoolOid())) {
            criteria.and("schoolOid").is(param.getSchoolOid());
        }

        if (param.getCardType() != null) {
            criteria.and("cardType").is(param.getCardType());
        }

        if (param.getIsUsed() != null) {
            criteria.and("isUsed").is(param.getIsUsed());
        }

        if (!CommonUtil.longIsEmpty(param.getStartTime()) && !CommonUtil.longIsEmpty(param.getEndTime())) {
            criteria.and("createTime").gte(param.getStartTime()).and("createTime").lte(param.getEndTime());
        }

        // 模糊搜索
        List<Criteria> criterias = new ArrayList<>();
        if (StringUtils.isNotEmpty(param.getName())) {
            Pattern pattern = Pattern.compile("^.*" + param.getName() + ".*$");
            criterias.add(Criteria.where("name").is(pattern));
        }
        if (StringUtils.isNotEmpty(param.getCode())) {
            Pattern pattern = Pattern.compile("^.*" + param.getCode() + ".*$");
            criterias.add(Criteria.where("code").is(pattern));
        }
        if (StringUtils.isNotEmpty(param.getUid())) {
            Pattern pattern = Pattern.compile("^.*" + param.getUid() + ".*$");
            criterias.add(Criteria.where("uid").is(pattern));
        }

        if (StringUtils.isNotEmpty(param.getKeyWord())) {
            Pattern pattern = Pattern.compile("^.*" + param.getKeyWord() + ".*$");
            criteria.orOperator(
                    Criteria.where("name").regex(pattern),
                    Criteria.where("code").regex(pattern),
                    Criteria.where("uid").regex(pattern)
            );
        }


        criteria.and("isDelete").is(Boolean.FALSE);

        Sort sort = buildSort(param);
        Query query = Query.query(criteria);
        query.with(sort);
        return dbHelper.pages(query, pageable, CardInfoPool.class);
    }

}
